using System.Collections.Generic;
using UnityEngine;
using SimpleJSON;
using System.Collections;
using UnityEngine.Events;
using UnityEngine.UI;

/* 95% written by MeshedVR
Doc'0c adapted it to a plugin
*/
namespace ReVAMped
{

    public class WindControl : MVRScript
    {
        Atom windDirection;
        public static Vector3 globalWind = Vector3.zero;
        protected static Vector3  newDirection = Vector3.zero;
        protected string _missingReceiverStoreId = string.Empty;
        public bool isGlobal;
		public bool isAvatar;
        public bool isRadial;
        public bool isBlowing;
        public bool isBySpeed;
        public bool isByRotation;
        protected float windRandomX;
        protected float windRandomY;
        protected float windRandomZ;
        protected JSONStorableBool isGlobalJSON;
		protected JSONStorableBool isAvatarJSON;
        protected JSONStorableBool isBlowingJSON;
        protected JSONStorableBool isBySpeedJSON;
        protected JSONStorableBool isByRotationJSON;
        protected Atom receivingAtom;
        protected JSONStorableStringChooser atomJSON;
        protected JSONStorable receiver;
        protected JSONStorableStringChooser receiverJSON;
        protected string _receiverTargetName;
        protected JSONStorableVector3 receiverTarget;
        protected JSONStorableStringChooser receiverTargetJSON;
        protected JSONStorableFloat currentMagnitudeJSON;
        protected JSONStorableBool autoJSON;
        protected JSONStorableFloat periodJSON;
        protected JSONStorableFloat quicknessJSON;
        protected JSONStorableFloat windDecay;
        protected JSONStorableFloat avatarMobility;
        protected JSONStorableFloat windStrength;
        protected JSONStorableFloat windTurbulence;
        protected JSONStorableFloat speedThreshold;
        protected JSONStorableFloat speedQuickness;
        protected JSONStorableFloat speedMultiplier;
        protected JSONStorableFloat targetMagnitudeJSON;
        protected JSONStorableFloat lowerMagnitudeJSON;
        protected JSONStorableFloat lowerMagnitudeRatioJSON;
        protected JSONStorableFloat upperMagnitudeJSON;
        protected float timer;
        protected Vector3 direction;
        protected Dictionary<string, ForceReceiver> receiverNameToForceReceiver;
        protected Rigidbody RB;
        protected UIDynamicButton btn;
        protected string _lastBrowseDir;

        protected JSONStorableFloat mobility_strong;
        protected JSONStorableFloat mobility_medium;
        protected JSONStorableFloat mobility_light;
        protected JSONStorableFloat mobility_controller;

        protected JSONStorableBool isRadialJSON;

        protected Dictionary<string, bool> RB_enabled;
        protected Dictionary<string, JSONStorableFloat> RB_mobility;

        protected float timer2=0;
        protected float speed;
        protected float oldSpeed;

        protected void SyncReceiverRB(string receiver)
        {
            if (receiver != null)
            {
                ForceReceiver fr;
                if (receiverNameToForceReceiver.TryGetValue(receiver, out fr))
                {
                    RB = fr.GetComponent<Rigidbody>();
                }
                else
                {
                    RB = null;
                }
            }
            else
            {
                RB = null;
            }
        }

        protected void initRBdicts()
        {
            RB_enabled = new Dictionary<string, bool>();
            RB_mobility = new Dictionary<string, JSONStorableFloat>();

            mobility_light=new JSONStorableFloat("mobility_light", 1f, 0.1f, 1.0f, true, true);
            mobility_strong=new JSONStorableFloat("mobility_strong", 0.1f, 0.1f, 1.0f, true, true);
            mobility_medium=new JSONStorableFloat("mobility_medium", 0.5f, 0.1f, 1.0f, true, true);
            mobility_controller=new JSONStorableFloat("mobility_controller", 0.1f, 0.1f, 1.0f, true, true);
        }

        protected void SetDefaultRBmobility()
        {
            RB_mobility.Add("rNipple",mobility_light);
            RB_mobility.Add("lNipple",mobility_light);
            RB_mobility.Add("pelvis",mobility_strong);
            RB_mobility.Add("hip",mobility_strong);
            RB_mobility.Add("rThigh",mobility_light);
            RB_mobility.Add("lThigh",mobility_light);
            RB_mobility.Add("rShin",mobility_light);
            RB_mobility.Add("lShin",mobility_light);
            RB_mobility.Add("rFoot",mobility_controller);
            RB_mobility.Add("lFoot",mobility_controller);
            RB_mobility.Add("LGlute",mobility_medium);
            RB_mobility.Add("RGlute",mobility_medium);
            RB_mobility.Add("abdomen",mobility_light);
            RB_mobility.Add("abdomen2",mobility_light);
            RB_mobility.Add("chest",mobility_controller);
            RB_mobility.Add("rCollar",mobility_light);
            RB_mobility.Add("lCollar",mobility_light);
            RB_mobility.Add("rShldr",mobility_light);
            RB_mobility.Add("lShldr",mobility_light);
            RB_mobility.Add("rForeArm",mobility_light);
            RB_mobility.Add("lForeArm",mobility_light);
            RB_mobility.Add("rHand",mobility_controller);
            RB_mobility.Add("lHand",mobility_controller);
            RB_mobility.Add("rPectoral",mobility_medium);
            RB_mobility.Add("lPectoral",mobility_medium);
            RB_mobility.Add("neck",mobility_light);
            RB_mobility.Add("head",mobility_light);
        }

        protected void SetDefaultRBenabled()
        {
            RB_enabled.Add("rNipple",false);
            RB_enabled.Add("lNipple",false);
            RB_enabled.Add("pelvis",false);
            RB_enabled.Add("hip",false);
            RB_enabled.Add("rThigh",false);
            RB_enabled.Add("lThigh",false);
            RB_enabled.Add("rShin",false);
            RB_enabled.Add("lShin",false);
            RB_enabled.Add("rFoot",false);
            RB_enabled.Add("lFoot",false);
            RB_enabled.Add("LGlute",false);
            RB_enabled.Add("RGlute",false);
            RB_enabled.Add("abdomen",false);
            RB_enabled.Add("abdomen2",false);
            RB_enabled.Add("chest",false);
            RB_enabled.Add("rCollar",false);
            RB_enabled.Add("lCollar",false);
            RB_enabled.Add("rShldr",false);
            RB_enabled.Add("lShldr",false);
            RB_enabled.Add("rForeArm",false);
            RB_enabled.Add("lForeArm",false);
            RB_enabled.Add("rHand",false);
            RB_enabled.Add("lHand",false);
            RB_enabled.Add("rPectoral",false);
            RB_enabled.Add("lPectoral",false);
            RB_enabled.Add("neck",false);
            RB_enabled.Add("head",false);
        }

        protected void RBpreset_disableAll()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=false;
            this.GetBoolJSONParam("lNipple RigidBody").val=false;
            this.GetBoolJSONParam("pelvis RigidBody").val=false;
            this.GetBoolJSONParam("hip RigidBody").val=false;
            this.GetBoolJSONParam("rThigh RigidBody").val=false;
            this.GetBoolJSONParam("lThigh RigidBody").val=false;
            this.GetBoolJSONParam("rShin RigidBody").val=false;
            this.GetBoolJSONParam("lShin RigidBody").val=false;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=false;
            this.GetBoolJSONParam("RGlute RigidBody").val=false;
            this.GetBoolJSONParam("abdomen RigidBody").val=false;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=false;
            this.GetBoolJSONParam("chest RigidBody").val=false;
            this.GetBoolJSONParam("rCollar RigidBody").val=false;
            this.GetBoolJSONParam("lCollar RigidBody").val=false;
            this.GetBoolJSONParam("rShldr RigidBody").val=false;
            this.GetBoolJSONParam("lShldr RigidBody").val=false;
            this.GetBoolJSONParam("rForeArm RigidBody").val=false;
            this.GetBoolJSONParam("lForeArm RigidBody").val=false;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=false;
            this.GetBoolJSONParam("lPectoral RigidBody").val=false;
            this.GetBoolJSONParam("neck RigidBody").val=false;
            this.GetBoolJSONParam("head RigidBody").val=false;
        }

        protected void RBpreset_enableAll()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=true;
            this.GetBoolJSONParam("lFoot RigidBody").val=true;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=true;
            this.GetBoolJSONParam("lHand RigidBody").val=true;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableMain()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=false;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=false;
            this.GetBoolJSONParam("lThigh RigidBody").val=false;
            this.GetBoolJSONParam("rShin RigidBody").val=false;
            this.GetBoolJSONParam("lShin RigidBody").val=false;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=false;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=false;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=false;
            this.GetBoolJSONParam("lCollar RigidBody").val=false;
            this.GetBoolJSONParam("rShldr RigidBody").val=false;
            this.GetBoolJSONParam("lShldr RigidBody").val=false;
            this.GetBoolJSONParam("rForeArm RigidBody").val=false;
            this.GetBoolJSONParam("lForeArm RigidBody").val=false;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=false;
            this.GetBoolJSONParam("head RigidBody").val=false;
        }

        protected void RBpreset_floatVal()
        {
            this.GetFloatJSONParam("rNippleFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lNippleFloat").val=mobility_light.val;
            this.GetFloatJSONParam("pelvisFloat").val=mobility_strong.val;
            this.GetFloatJSONParam("hipFloat").val=mobility_strong.val;
            this.GetFloatJSONParam("rThighFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lThighFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rShinFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lShinFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rFootFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("lFootFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("LGluteFloat").val=mobility_medium.val;
            this.GetFloatJSONParam("RGluteFloat").val=mobility_medium.val;
            this.GetFloatJSONParam("abdomenFloat").val=mobility_light.val;
            this.GetFloatJSONParam("abdomen2Float").val=mobility_light.val;
            this.GetFloatJSONParam("chestFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("rCollarFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lCollarFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rShldrFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lShldrFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rForeArmFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lForeArmFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rHandFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("lHandFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("rPectoralFloat").val=mobility_medium.val;
            this.GetFloatJSONParam("lPectoralFloat").val=mobility_medium.val;
            this.GetFloatJSONParam("neckFloat").val=mobility_light.val;
            this.GetFloatJSONParam("headFloat").val=mobility_controller.val;
        }

        protected void debug_print_dictionary()
        {
            foreach(KeyValuePair<string,bool> RB_elem in RB_enabled){
                SuperController.LogMessage("updated RB:"+RB_elem.Key+" val:"+RB_enabled[RB_elem.Key]+"");
            }
        }
        
        protected void SyncIsGlobal(bool b)
        {
            isGlobal = b;
        }
		
		protected void SyncIsAvatar(bool b)
        {
            isAvatar = b;
        }

        protected void SyncIsBlowing(bool b)
        {
            isBlowing = b;
        }

        protected void SyncIsBySpeed(bool b)
        {
            isBySpeed = b;
        }

        protected void SyncIsByRotation(bool b)
        {
            isByRotation = b;
        }

        protected void SyncIsRadial(bool b)
        {
            isRadial = b;
        }

        protected void SyncAtomChoices()
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            foreach (string atomUiD in SuperController.singleton.GetAtomUIDs())
                stringList.Add(atomUiD);
            atomJSON.choices = stringList;
        }

        protected void OnAtomRename(string oldid, string newid)
        {
            SyncAtomChoices();
            if (atomJSON == null || !(receivingAtom != null))
                return;
            atomJSON.valNoCallback = receivingAtom.uid;
        }

        protected void SyncAtom(string atomUID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (atomUID != null)
            {
                receivingAtom = SuperController.singleton.GetAtomByUid(atomUID);
                if (receivingAtom != null)
                {
                    foreach (string storableId in receivingAtom.GetStorableIDs())
                    {
                        stringList.Add(storableId);
                    }
                    receiverNameToForceReceiver = new Dictionary<string, ForceReceiver>();
                    foreach (ForceReceiver fr in receivingAtom.forceReceivers)
                    {
                        receiverNameToForceReceiver.Add(fr.name, fr);
                    }
                }
            }
            else
                receivingAtom = (Atom)null;

            receiverJSON.choices = stringList;
            receiverJSON.val = "None";
        }

        protected void CheckMissingReceiver()
        {
            if (!(_missingReceiverStoreId != string.Empty)
                || !(receivingAtom != null)
                || !(receivingAtom.GetStorableByID(_missingReceiverStoreId) != null))
                return;

            string receiverTargetName = _receiverTargetName;
            SyncReceiver(_missingReceiverStoreId);
            _missingReceiverStoreId = string.Empty;
            insideRestore = true;
            receiverTargetJSON.val = receiverTargetName;
            insideRestore = false;
        }

        protected void SyncReceiver(string receiverID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (receivingAtom != null && receiverID != null)
            {
                receiver = receivingAtom.GetStorableByID(receiverID);
                if (receiver != null)
                {
                    foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                    {
                        stringList.Add(vector3ParamName);
                    }
                }
                else if (receiverID != "None")
                    _missingReceiverStoreId = receiverID;
            }
            else
            {
                receiver = null;
            }

            receiverTargetJSON.choices = stringList;
            receiverTargetJSON.val = "None";
        }

        protected void SyncReceiverTarget(string receiverTargetName)
        {
            _receiverTargetName = receiverTargetName;
            receiverTarget = (JSONStorableVector3)null;
            if (receiver != null && receiverTargetName != null)
                receiverTarget = receiver.GetVector3JSONParam(receiverTargetName);
        }

        public UIDynamicTextField CreateTextInput(JSONStorableString jss, bool rightSide = false)
        {
            var textfield = CreateTextField(jss, rightSide);
            textfield.height = 1f;
            //textfield.backgroundColor = Color.white;
            var input = textfield.gameObject.AddComponent<InputField>();
            var rect = input.GetComponent<RectTransform>().sizeDelta = new Vector2(1f, 0.4f);
            input.textComponent = textfield.UItext;
            jss.inputField = input;
            return textfield;
        }

        public void SavePreset(string aPath)
        {
            if (System.String.IsNullOrEmpty(aPath))
            {
                return;
            }
            _lastBrowseDir = aPath.Substring(0, aPath.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";

            if (!aPath.ToLower().EndsWith("WindControl".ToLower()))
            {
                aPath += "." + "WindControl";
            }
            JSONClass saveJson = new JSONClass();
            saveJson["savedBy"] = "WindControl";

            saveJson["rNippleFloat"] = this.GetFloatJSONParam("rNippleFloat").val.ToString();
            saveJson["lNippleFloat"] = this.GetFloatJSONParam("lNippleFloat").val.ToString();
            saveJson["pelvisFloat"] = this.GetFloatJSONParam("pelvisFloat").val.ToString();
            saveJson["hipFloat"] = this.GetFloatJSONParam("hipFloat").val.ToString();
            saveJson["rThighFloat"] = this.GetFloatJSONParam("rThighFloat").val.ToString();
            saveJson["lThighFloat"] = this.GetFloatJSONParam("lThighFloat").val.ToString();
            saveJson["rShinFloat"] = this.GetFloatJSONParam("rShinFloat").val.ToString();
            saveJson["lShinFloat"] = this.GetFloatJSONParam("lShinFloat").val.ToString();
            saveJson["rFootFloat"] = this.GetFloatJSONParam("rFootFloat").val.ToString();
            saveJson["lFootFloat"] = this.GetFloatJSONParam("lFootFloat").val.ToString();
            saveJson["LGluteFloat"] = this.GetFloatJSONParam("LGluteFloat").val.ToString();
            saveJson["RGluteFloat"] = this.GetFloatJSONParam("RGluteFloat").val.ToString();
            saveJson["abdomenFloat"] = this.GetFloatJSONParam("abdomenFloat").val.ToString();
            saveJson["abdomen2Float"] = this.GetFloatJSONParam("abdomen2Float").val.ToString();
            saveJson["chestFloat"] = this.GetFloatJSONParam("chestFloat").val.ToString();
            saveJson["rCollarFloat"] = this.GetFloatJSONParam("rCollarFloat").val.ToString();
            saveJson["lCollarFloat"] = this.GetFloatJSONParam("lCollarFloat").val.ToString();
            saveJson["rShldrFloat"] = this.GetFloatJSONParam("rShldrFloat").val.ToString();
            saveJson["lShldrFloat"] = this.GetFloatJSONParam("lShldrFloat").val.ToString();
            saveJson["rForeArmFloat"] = this.GetFloatJSONParam("rForeArmFloat").val.ToString();
            saveJson["lForeArmFloat"] = this.GetFloatJSONParam("lForeArmFloat").val.ToString();
            saveJson["rHandFloat"] = this.GetFloatJSONParam("rHandFloat").val.ToString();
            saveJson["lHandFloat"] = this.GetFloatJSONParam("lHandFloat").val.ToString();
            saveJson["rPectoralFloat"] = this.GetFloatJSONParam("rPectoralFloat").val.ToString();
            saveJson["lPectoralFloat"] = this.GetFloatJSONParam("lPectoralFloat").val.ToString();
            saveJson["neckFloat"] = this.GetFloatJSONParam("neckFloat").val.ToString();
            saveJson["headFloat"] = this.GetFloatJSONParam("headFloat").val.ToString();

            saveJson["rNipple RigidBody"] = this.GetBoolJSONParam("rNipple RigidBody").val.ToString();
            saveJson["lNipple RigidBody"] = this.GetBoolJSONParam("lNipple RigidBody").val.ToString();
            saveJson["pelvis RigidBody"] = this.GetBoolJSONParam("pelvis RigidBody").val.ToString();
            saveJson["hip RigidBody"] = this.GetBoolJSONParam("hip RigidBody").val.ToString();
            saveJson["rThigh RigidBody"] = this.GetBoolJSONParam("rThigh RigidBody").val.ToString();
            saveJson["lThigh RigidBody"] = this.GetBoolJSONParam("lThigh RigidBody").val.ToString();
            saveJson["rShin RigidBody"] = this.GetBoolJSONParam("rShin RigidBody").val.ToString();
            saveJson["lShin RigidBody"] = this.GetBoolJSONParam("lShin RigidBody").val.ToString();
            saveJson["rFoot RigidBody"] = this.GetBoolJSONParam("rFoot RigidBody").val.ToString();
            saveJson["lFoot RigidBody"] = this.GetBoolJSONParam("lFoot RigidBody").val.ToString();
            saveJson["LGlute RigidBody"] = this.GetBoolJSONParam("LGlute RigidBody").val.ToString();
            saveJson["RGlute RigidBody"] = this.GetBoolJSONParam("RGlute RigidBody").val.ToString();
            saveJson["abdomen RigidBody"] = this.GetBoolJSONParam("abdomen RigidBody").val.ToString();
            saveJson["abdomen2 RigidBody"] = this.GetBoolJSONParam("abdomen2 RigidBody").val.ToString();
            saveJson["chest RigidBody"] = this.GetBoolJSONParam("chest RigidBody").val.ToString();
            saveJson["rCollar RigidBody"] = this.GetBoolJSONParam("rCollar RigidBody").val.ToString();
            saveJson["lCollar RigidBody"] = this.GetBoolJSONParam("lCollar RigidBody").val.ToString();
            saveJson["rShldr RigidBody"] = this.GetBoolJSONParam("rShldr RigidBody").val.ToString();
            saveJson["lShldr RigidBody"] = this.GetBoolJSONParam("lShldr RigidBody").val.ToString();
            saveJson["rForeArm RigidBody"] = this.GetBoolJSONParam("rForeArm RigidBody").val.ToString();
            saveJson["lForeArm RigidBody"] = this.GetBoolJSONParam("lForeArm RigidBody").val.ToString();
            saveJson["rHand RigidBody"] = this.GetBoolJSONParam("rHand RigidBody").val.ToString();
            saveJson["lHand RigidBody"] = this.GetBoolJSONParam("lHand RigidBody").val.ToString();
            saveJson["rPectoral RigidBody"] = this.GetBoolJSONParam("rPectoral RigidBody").val.ToString();
            saveJson["lPectoral RigidBody"] = this.GetBoolJSONParam("lPectoral RigidBody").val.ToString();
            saveJson["neck RigidBody"] = this.GetBoolJSONParam("neck RigidBody").val.ToString();
            saveJson["head RigidBody"] = this.GetBoolJSONParam("head RigidBody").val.ToString();

            this.SaveJSON(saveJson, aPath);
        }

        void LoadPreset(string aPath)
        {
            if (System.String.IsNullOrEmpty(aPath))
            {
                return;
            }
            _lastBrowseDir = aPath.Substring(0, aPath.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";
            var aJson = this.LoadJSON(aPath);

            this.GetFloatJSONParam("rNippleFloat").val=aJson["rNippleFloat"].AsFloat;
            this.GetFloatJSONParam("lNippleFloat").val=aJson["lNippleFloat"].AsFloat;
            this.GetFloatJSONParam("pelvisFloat").val=aJson["pelvisFloat"].AsFloat;
            this.GetFloatJSONParam("hipFloat").val=aJson["hipFloat"].AsFloat;
            this.GetFloatJSONParam("rThighFloat").val=aJson["rThighFloat"].AsFloat;
            this.GetFloatJSONParam("lThighFloat").val=aJson["lThighFloat"].AsFloat;
            this.GetFloatJSONParam("rShinFloat").val=aJson["rShinFloat"].AsFloat;
            this.GetFloatJSONParam("lShinFloat").val=aJson["lShinFloat"].AsFloat;
            this.GetFloatJSONParam("rFootFloat").val=aJson["rFootFloat"].AsFloat;
            this.GetFloatJSONParam("lFootFloat").val=aJson["lFootFloat"].AsFloat;
            this.GetFloatJSONParam("LGluteFloat").val=aJson["LGluteFloat"].AsFloat;
            this.GetFloatJSONParam("RGluteFloat").val=aJson["RGluteFloat"].AsFloat;
            this.GetFloatJSONParam("abdomenFloat").val=aJson["abdomenFloat"].AsFloat;
            this.GetFloatJSONParam("abdomen2Float").val=aJson["abdomen2Float"].AsFloat;
            this.GetFloatJSONParam("chestFloat").val=aJson["chestFloat"].AsFloat;
            this.GetFloatJSONParam("rCollarFloat").val=aJson["rCollarFloat"].AsFloat;
            this.GetFloatJSONParam("lCollarFloat").val=aJson["lCollarFloat"].AsFloat;
            this.GetFloatJSONParam("rShldrFloat").val=aJson["rShldrFloat"].AsFloat;
            this.GetFloatJSONParam("lShldrFloat").val=aJson["lShldrFloat"].AsFloat;
            this.GetFloatJSONParam("rForeArmFloat").val=aJson["rForeArmFloat"].AsFloat;
            this.GetFloatJSONParam("lForeArmFloat").val=aJson["lForeArmFloat"].AsFloat;
            this.GetFloatJSONParam("rHandFloat").val=aJson["rHandFloat"].AsFloat;
            this.GetFloatJSONParam("lHandFloat").val=aJson["lHandFloat"].AsFloat;
            this.GetFloatJSONParam("rPectoralFloat").val=aJson["rPectoralFloat"].AsFloat;
            this.GetFloatJSONParam("lPectoralFloat").val=aJson["lPectoralFloat"].AsFloat;
            this.GetFloatJSONParam("neckFloat").val=aJson["neckFloat"].AsFloat;
            this.GetFloatJSONParam("headFloat").val=aJson["headFloat"].AsFloat;

            this.GetBoolJSONParam("rNipple RigidBody").val=aJson["rNipple RigidBody"].AsBool;
            this.GetBoolJSONParam("lNipple RigidBody").val=aJson["lNipple RigidBody"].AsBool;
            this.GetBoolJSONParam("pelvis RigidBody").val=aJson["pelvis RigidBody"].AsBool;
            this.GetBoolJSONParam("hip RigidBody").val=aJson["hip RigidBody"].AsBool;
            this.GetBoolJSONParam("rThigh RigidBody").val=aJson["rThigh RigidBody"].AsBool;
            this.GetBoolJSONParam("lThigh RigidBody").val=aJson["lThigh RigidBody"].AsBool;
            this.GetBoolJSONParam("rShin RigidBody").val=aJson["rShin RigidBody"].AsBool;
            this.GetBoolJSONParam("lShin RigidBody").val=aJson["lShin RigidBody"].AsBool;
            this.GetBoolJSONParam("rFoot RigidBody").val=aJson["rFoot RigidBody"].AsBool;
            this.GetBoolJSONParam("lFoot RigidBody").val=aJson["lFoot RigidBody"].AsBool;
            this.GetBoolJSONParam("LGlute RigidBody").val=aJson["LGlute RigidBody"].AsBool;
            this.GetBoolJSONParam("RGlute RigidBody").val=aJson["RGlute RigidBody"].AsBool;
            this.GetBoolJSONParam("abdomen RigidBody").val=aJson["abdomen RigidBody"].AsBool;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=aJson["abdomen2 RigidBody"].AsBool;
            this.GetBoolJSONParam("chest RigidBody").val=aJson["chest RigidBody"].AsBool;
            this.GetBoolJSONParam("rCollar RigidBody").val=aJson["rCollar RigidBody"].AsBool;
            this.GetBoolJSONParam("lCollar RigidBody").val=aJson["lCollar RigidBody"].AsBool;
            this.GetBoolJSONParam("rShldr RigidBody").val=aJson["rShldr RigidBody"].AsBool;
            this.GetBoolJSONParam("lShldr RigidBody").val=aJson["lShldr RigidBody"].AsBool;
            this.GetBoolJSONParam("rForeArm RigidBody").val=aJson["rForeArm RigidBody"].AsBool;
            this.GetBoolJSONParam("lForeArm RigidBody").val=aJson["lForeArm RigidBody"].AsBool;
            this.GetBoolJSONParam("rHand RigidBody").val=aJson["rHand RigidBody"].AsBool;
            this.GetBoolJSONParam("lHand RigidBody").val=aJson["lHand RigidBody"].AsBool;
            this.GetBoolJSONParam("rPectoral RigidBody").val=aJson["rPectoral RigidBody"].AsBool;
            this.GetBoolJSONParam("lPectoral RigidBody").val=aJson["lPectoral RigidBody"].AsBool;
            this.GetBoolJSONParam("neck RigidBody").val=aJson["neck RigidBody"].AsBool;
            this.GetBoolJSONParam("head RigidBody").val=aJson["head RigidBody"].AsBool;


        }

        public override void Init()
        {
            try
            {
                initRBdicts();
                SetDefaultRBmobility();
                SetDefaultRBenabled();

                if ((bool)(SuperController.singleton))
                    SuperController.singleton.onAtomUIDRenameHandlers += new SuperController.OnAtomUIDRename(OnAtomRename);

                
                isGlobalJSON = new JSONStorableBool("Affect Cloth/Hair", false, new JSONStorableBool.SetBoolCallback(SyncIsGlobal));
				isAvatarJSON = new JSONStorableBool("Affect Avatar", false, new JSONStorableBool.SetBoolCallback(SyncIsAvatar));

                atomJSON = new JSONStorableStringChooser(
                  "atom", SuperController.singleton.GetAtomUIDs(), (string)null,
                  "Atom", new JSONStorableStringChooser.SetStringCallback(SyncAtom));

                atomJSON.popupOpenCallback = new JSONStorableStringChooser.PopupOpenCallback(SyncAtomChoices);
                receiverJSON = new JSONStorableStringChooser(
                  "receiver", (List<string>)null, (string)null,
                  "Receiver", new JSONStorableStringChooser.SetStringCallback(SyncReceiver));


                receiverTargetJSON = new JSONStorableStringChooser(
                  "receiverTarget", (List<string>)null, (string)null,
                  "Target", new JSONStorableStringChooser.SetStringCallback(SyncReceiverTarget));

                currentMagnitudeJSON = new JSONStorableFloat("Current Magnitude (view)", 0.0f, -50f, 50f, false, true);
                autoJSON = new JSONStorableBool("Randomize Current Magnitude", true);
                periodJSON = new JSONStorableFloat("period", 0.03f, 0.0f, 10f, false, true);
                quicknessJSON = new JSONStorableFloat("quickness", 30f, 0.0f, 100f, true, true);
                lowerMagnitudeJSON = new JSONStorableFloat("Lower Magnitude (view)", -50f, -50f, 200f, false, true);
                lowerMagnitudeRatioJSON = new JSONStorableFloat("Lower Magnitude Coeff", -0.25f, -1f, 1f, true, true);
                upperMagnitudeJSON = new JSONStorableFloat("upperMagnitude", 150f, -50f, 150f, false, true);
                targetMagnitudeJSON = new JSONStorableFloat("targetMagnitude", 0.0f, -50f, 50f, false, false);
                
                avatarMobility = new JSONStorableFloat("Avatar Mobility", 2f, 0.5f, 10f, true, true);
                windStrength = new JSONStorableFloat("Wind Strength", 0f, 0.0f, 300f, false, true);
                windTurbulence = new JSONStorableFloat("Wind dir Turbulence", 0.5f, 0.0f, 1.0f, false, true);

                speedThreshold = new JSONStorableFloat("Velocity Threshold", 1f, 0.0f, 10f, false, true);
                speedMultiplier = new JSONStorableFloat("Velocity Multiplier", 10f, 0.0f, 10f, false, true);
                speedQuickness = new JSONStorableFloat("Interpolation rate", 10f, 0.0f, 10f, false, true);

                //RIGIDBODIES
                foreach(KeyValuePair<string,bool> RB_elem in RB_enabled)
                {
                    //Now you can access the key and value both separately from this attachStat as:
                    //SuperController.LogMessage("RB:"+RB_elem.Key+" val:"+RB_elem.Value+"");
                    var tempRB_enab = new JSONStorableBool(RB_elem.Key+" RigidBody", RB_elem.Value,(bool enabled)=>
                    {
                        RB_enabled[RB_elem.Key]=enabled;
                        //SuperController.LogMessage("updated RB:"+RB_elem.Key+" val:"+RB_enabled[RB_elem.Key]+"");
                    });
                    RegisterBool(tempRB_enab);
                    //SuperController.LogMessage("RB:"+tempRB_enab.val+" val:"+RB_elem.Value+"");
                    CreateToggle(tempRB_enab,true);
                    var temp_mobility=RB_mobility[RB_elem.Key].val;
                    RB_mobility[RB_elem.Key] = new JSONStorableFloat(RB_elem.Key+" Mobility", temp_mobility, 0.1f, 1.0f, true, true);
                    RegisterFloat(RB_mobility[RB_elem.Key]);   
                    CreateSlider(RB_mobility[RB_elem.Key],true);
                }
                RBpreset_enableMain();
                RegisterStringChooser(atomJSON);
                CreateScrollablePopup(atomJSON, false);

                isRadialJSON = new JSONStorableBool("Radial Wind", false, (bool b)=>{
                SyncIsRadial(b); });
                isBlowingJSON = new JSONStorableBool("Suck/Blow", false, new JSONStorableBool.SetBoolCallback(SyncIsBlowing));
                isBySpeedJSON = new JSONStorableBool("Velocity = Wind Stength", false, new JSONStorableBool.SetBoolCallback(SyncIsBySpeed));
                isByRotationJSON = new JSONStorableBool("Speed/Rotation", false, new JSONStorableBool.SetBoolCallback(SyncIsByRotation));
                
                windDecay = new JSONStorableFloat("Wind Decay", 0f, 0f, 1f, false, true);
                


				RegisterBool(isAvatarJSON);
                RegisterBool(isGlobalJSON);

                RegisterBool(autoJSON);
                RegisterFloat(periodJSON);
                RegisterFloat(quicknessJSON);
                RegisterFloat(upperMagnitudeJSON);
                RegisterFloat(lowerMagnitudeJSON);
                RegisterFloat(lowerMagnitudeRatioJSON);
                RegisterFloat(currentMagnitudeJSON);
                RegisterFloat(windStrength);
                RegisterFloat(windTurbulence);
                RegisterFloat(avatarMobility);

                
                CreateToggle(isAvatarJSON);
                CreateToggle(isGlobalJSON);
                CreateToggle(autoJSON);
                CreateSlider(windStrength);
                CreateSlider(currentMagnitudeJSON);
                 
                CreateSlider(lowerMagnitudeRatioJSON);
                CreateSlider(lowerMagnitudeJSON);
                CreateSlider(windTurbulence);
                CreateSlider(avatarMobility);

                RegisterBool(isRadialJSON);
                var tmpToggle = CreateToggle(isRadialJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                tmpToggle = CreateToggle(isBlowingJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isBlowingJSON);
                var tmpSlider = CreateSlider(windDecay);
                color_slider(tmpSlider, Color.white, Color.grey);
                RegisterFloat(windDecay);

                tmpToggle = CreateToggle(isBySpeedJSON);
                color_toggle(tmpToggle,Color.black,Color.yellow);
                RegisterBool(isBySpeedJSON);
                tmpToggle = CreateToggle(isByRotationJSON);
                color_toggle(tmpToggle,Color.black,Color.yellow);
                RegisterBool(isByRotationJSON);
                RegisterFloat(speedThreshold);
                tmpSlider = CreateSlider(speedThreshold);
                color_slider(tmpSlider,Color.black, Color.yellow);
                RegisterFloat(speedMultiplier);
                tmpSlider = CreateSlider(speedMultiplier);
                color_slider(tmpSlider,Color.black, Color.yellow);
                RegisterFloat(speedQuickness);
                tmpSlider = CreateSlider(speedQuickness);
                color_slider(tmpSlider,Color.black, Color.yellow);

                //CreateTextInput(new JSONStorableString("info","COLLIDERS PRESETS"), false);
                var enable_main_btn = CreateButton("Enable Main Colliders", false);
                color_btn(enable_main_btn,Color.black,Color.green);
                enable_main_btn.button.onClick.AddListener(RBpreset_enableMain);
                JSONStorableAction enable_main_colliders_action = new JSONStorableAction("Enable Main Colliders", () => {RBpreset_enableMain();});
                RegisterAction(enable_main_colliders_action);

                var disable_all_btn = CreateButton("Disable all Colliders", false);
                color_btn(disable_all_btn,Color.black,Color.green);
                disable_all_btn.button.onClick.AddListener(RBpreset_disableAll);
                JSONStorableAction disable_all_colliders_action = new JSONStorableAction("Disable All Colliders", () => {RBpreset_disableAll();});
                RegisterAction(disable_all_colliders_action);

                var enable_all_btn = CreateButton("Enable all Colliders", false);
                color_btn(enable_all_btn,Color.black,Color.green);
                enable_all_btn.button.onClick.AddListener(RBpreset_enableAll);
                JSONStorableAction enable_all_colliders_action = new JSONStorableAction("Enable All Colliders", () => {RBpreset_enableAll();});
                RegisterAction(enable_all_colliders_action);

                var reset_all_float_btn = CreateButton("Reset all Colliders Values", false);
                color_btn(reset_all_float_btn,Color.black,Color.green);
                reset_all_float_btn.button.onClick.AddListener(RBpreset_floatVal);
                JSONStorableAction reset_all_colliders_float_action = new JSONStorableAction("Reset All Colliders Values", () => {RBpreset_floatVal();});
                RegisterAction(reset_all_colliders_float_action);

                btn = CreateButton("Save Colliders Preset");
                color_btn(btn,Color.white,Color.blue);
                btn.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.NormalizeMediaPath(_lastBrowseDir);
                    SuperController.singleton.GetMediaPathDialog(SavePreset, "WindControl");

                uFileBrowser.FileBrowser browser = SuperController.singleton.mediaFileBrowserUI;
                    browser.SetTextEntry(true);
                    browser.fileEntryField.text = System.String.Format("{0}.{1}", ((int)(System.DateTime.UtcNow - new System.DateTime(1970, 1, 1)).TotalSeconds).ToString(), "WindControl");
                    browser.ActivateFileNameField();
                });

                btn = CreateButton("Load Colliders Preset");
                color_btn(btn,Color.white,Color.blue);
                btn.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.NormalizeMediaPath(_lastBrowseDir);
                    SuperController.singleton.GetMediaPathDialog(LoadPreset, "WindControl");
                });

            }
            catch (System.Exception e)
            {
                SuperController.LogError("" + e);
            }
        }


        protected void Update()
        {
            if (currentMagnitudeJSON == null)
                return;
            if (autoJSON != null && autoJSON.val)
            {
                timer -= Time.deltaTime;
                if ((double)timer < 0.0)
                {
                    timer = periodJSON.val;
                    //lowerMagnitudeJSON.val=-(windStrength.val/4);
                    lowerMagnitudeJSON.val=windStrength.val*lowerMagnitudeRatioJSON.val;
                    upperMagnitudeJSON.val=windStrength.val;
                    quicknessJSON.val=windStrength.val/5;
                    periodJSON.val=0.2f-(windStrength.val/1000);
                    if(periodJSON.val<0.03f)
                    {
                        periodJSON.val=0.03f;
                    }
                    targetMagnitudeJSON.val = Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
                }
                if(windStrength.val==0)
                {
                    currentMagnitudeJSON.val=0;
                }
                else
                {
                    if(isBySpeed)
                    {
                        strengthByVelocity();
                    }
                    else
                    {
                        currentMagnitudeJSON.val = Mathf.Lerp(currentMagnitudeJSON.val, targetMagnitudeJSON.val, Time.deltaTime * quicknessJSON.val);
                    }
                }
            }
            else
            {
                if(isBySpeed)
                {
                   strengthByVelocity();
                }
                else
                {
                    currentMagnitudeJSON.val=windStrength.val;
                    lowerMagnitudeJSON.val=windStrength.val*lowerMagnitudeRatioJSON.val;
                    upperMagnitudeJSON.val=windStrength.val;
                }
                //lowerMagnitudeJSON.val=-(windStrength.val/4);
                
                quicknessJSON.val=windStrength.val/5;
                periodJSON.val=0.2f-(windStrength.val/1000);
                if(periodJSON.val<0.03f)
                {
                    periodJSON.val=0.03f;
                }
            }
            setWindTurbulence();
            if(isRadial)
            {
                windRandomY=Random.Range(-windTurbulence.val, windTurbulence.val);
                windRandomX=Random.Range(-windTurbulence.val, windTurbulence.val);
                windRandomZ=Random.Range(-windTurbulence.val, windTurbulence.val);
            }
            Vector3 vector3 = currentMagnitudeJSON.val * newDirection;
            if (isGlobal)
            {

                
                foreach (string storableId in receivingAtom.GetStorableIDs())
				{
					SyncReceiver(storableId);
                    
                    
					foreach (string vector3ParamName in receiver.GetVector3ParamNames())
					{
                        SyncReceiverTarget(vector3ParamName);
                        if(isRadial)
                        {
                            var WindController=containingAtom.GetStorableByID("control").transform;
                            Vector3 direction=(new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ)) - receivingAtom.GetStorableByID("chestControl").transform.position;
                            if (isBlowing)
                            {
                                direction=receivingAtom.GetStorableByID("chestControl").transform.position - (new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ));
                            }
                            var windVariance=Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
                            var distanceFactor=direction.magnitude;
                            var decayFactor=(distanceFactor-(distanceFactor*windDecay.val)+0.001f);
                            if(decayFactor<1)
                            {
                                decayFactor=1;
                            }
                            {
                                receiverTarget.val = (currentMagnitudeJSON.val+windVariance)/decayFactor*direction.normalized;
                            }
                        }
                        else
                        {
                            receiverTarget.val = currentMagnitudeJSON.val * newDirection;
                        }
					}
                    
                }
                
            }
            
			if (isAvatar)
			{
                //debug_print_dictionary();
                foreach(KeyValuePair<string,bool> RB_elem in RB_enabled)
                {
                    //Now you can access the key and value both separately from this attachStat as:
                    //SuperController.LogMessage("RB:"+RB_elem.Key+" val:"+RB_elem.Value+"");
                    if(RB_elem.Value)
                    {
                        if(isRadial)
                        {
                            updateControllerRadial(RB_elem.Key, RB_mobility[RB_elem.Key].val);
                        }
                        else
                        {
                            updateController(RB_elem.Key, RB_mobility[RB_elem.Key]);
                        }
                    }
                }
			}

        }

        protected void strengthByVelocity()
        {
            foreach (ForceReceiver fr in containingAtom.forceReceivers)
            {
                if(fr.name=="object")
                {
                    if(timer2<1)
                    {
                        timer2+=Time.deltaTime * speedQuickness.val;
                        currentMagnitudeJSON.val=Mathf.Lerp(oldSpeed, speed, timer2);
                    }
                    else
                    {
                        var RBvelocity=0f;
                        oldSpeed=speed;
                        var RB = fr.GetComponent<Rigidbody>();
                        if(isByRotation)
                        {
                            RBvelocity=RB.angularVelocity.magnitude;
                        }
                        else
                        {
                            RBvelocity=RB.velocity.magnitude;
                        }
                        speed=(RBvelocity-speedThreshold.val)*speedMultiplier.val;
                        if(speed<0){speed=0;}
                        timer2=0f;
                    }
                    upperMagnitudeJSON.val=speed;
                    lowerMagnitudeJSON.val=speed;
                }
            }
        }

        protected void updateController(string Controller, JSONStorableFloat mobility)
        {
            SyncReceiverRB(Controller);
            RB.AddForce((currentMagnitudeJSON.val+Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val))/(10*mobility.val*avatarMobility.val) * (newDirection));
        }

        protected void getDirection(string controller)
        {
            var WindController=containingAtom.GetStorableByID("control").transform;
            var AvatarController=receivingAtom.GetStorableByID(controller).transform;
            if (isBlowing)
            {
                direction=AvatarController.position - (new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ));
            }
            if (!isBlowing)
            {
                direction=(new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ)) - AvatarController.position;
            }
        }

        //Functions to color UI elements
        protected void color_slider(UIDynamicSlider slider, Color text,Color background)
        {
            var sliderBGImage = slider.GetComponentInChildren<Image>();
            sliderBGImage.color = background;
            slider.labelText.color=text;
        }

        protected void color_toggle(UIDynamicToggle toggle, Color text,Color background)
        {
            toggle.backgroundColor=background;
            toggle.textColor=text;
        }

        protected void color_btn(UIDynamicButton btn, Color text,Color background)
        {
            btn.buttonColor = background;
            btn.textColor = text;
        }


        protected void updateControllerRadial(string Controller, float mobility)
        {
            SyncReceiverRB(Controller);
            var WindController=containingAtom.GetStorableByID("control").transform;
            var currentController=receivingAtom.GetStorableByID(Controller).transform;
            var randomValue=Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
            var direction=(new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ)) - currentController.position;
            if (isBlowing)
            {
                direction=currentController.position - (new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ));
            }
            var windVariance=Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
            var distanceFactor=direction.magnitude;
            var decayFactor=(distanceFactor-(distanceFactor*windDecay.val)+(avatarMobility.val*5)*mobility);
            if(decayFactor<1)
            {
                decayFactor=1;
            }
            //currentController.position+=(((currentMagnitudeJSON.val+randomValue)/(10000/mobility*avatarMobility.val)) * direction.normalized * windDecay.val/(windDecay.val+direction.magnitude));
            RB.AddForce((currentMagnitudeJSON.val+windVariance)/decayFactor*direction.normalized);
        }

        protected void setControllerStateOff(string controller)
        {
            FreeControllerV3 headControl = receivingAtom.GetStorableByID(controller) as FreeControllerV3;
            headControl.currentPositionState=FreeControllerV3.PositionState.Off;
            headControl.currentRotationState=FreeControllerV3.RotationState.Off;
        }

        protected void setControllerStateComply(string controller)
        {
            FreeControllerV3 headControl = receivingAtom.GetStorableByID(controller) as FreeControllerV3;
            headControl.currentPositionState=FreeControllerV3.PositionState.Comply;
            headControl.currentRotationState=FreeControllerV3.RotationState.Comply;
        }

        protected void setWindTurbulence()
        {
            var windRandomY=Random.Range(0, windTurbulence.val);
            var windRandomX=Random.Range(-windTurbulence.val, windTurbulence.val);
            var windRandomZ=Random.Range(-windTurbulence.val, windTurbulence.val);
            newDirection = new Vector3(containingAtom.GetStorableByID("control").transform.forward.x + windRandomX, containingAtom.GetStorableByID("control").transform.forward.y , containingAtom.GetStorableByID("control").transform.forward.z + windRandomZ).normalized;
        }

        protected void OnDestroy()
        {
            if (SuperController.singleton)
                SuperController.singleton.onAtomUIDRenameHandlers -= new SuperController.OnAtomUIDRename(OnAtomRename);
        }
    }

}
